﻿Public Class MainWindow

    Dim ChGridSize As Integer = 30
    Dim DispOfset As Integer = 50
    Dim DispPos As Integer
    Dim DispZoom As Single
    Dim TmpDat(65536) As Byte
    Dim Marker(100) As StrucMarker
    Dim Chan(8) As StrucChannel

    Dim MouseInPbWave As Boolean
    Dim MouseXWave As Integer
    Dim MouseYWave As Integer
    Dim ClickX As Integer
    Dim ClickY As Integer
    Dim MouseIsDown As Boolean
    Dim DispPosTmp As Integer

    Dim ChanSel As Integer

    Dim ColorTraces As Boolean = False
    Dim ColorChann As Boolean = True
    Dim ColorChanDarken As Integer

    Dim ConNum As Integer
    Dim ConState As Integer
    Dim ConProg As Integer
    Dim ConSuc As Boolean
    Dim ConTimeout As Integer
    Dim ConIdent As String

    Private Structure StrucChannel
        Dim Data() As Boolean
        Dim Color As Color
        Dim Name As String
        Dim Triger As Integer
    End Structure

    Private Structure StrucMarker
        Dim Position As Integer
        Dim Color As Color
        Dim Name As String
    End Structure




    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        DispPos = 0
        DispZoom = 5
        Dim i As Integer
        For i = 0 To 10000
            TmpDat(i) = i And 255
        Next

        Marker(0).Position = 100
        Marker(0).Color = Color.Aqua

        Marker(1).Position = 50
        Marker(1).Color = Color.Aqua

        For i = 0 To 7
            Chan(i).Name = "Chan" & (i + 1)
            Chan(i).Color = Color.FromArgb(255, 190, 0)
        Next

        Application.DoEvents()
        RedrawTraces()
    End Sub


    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Me.Width < 800 Then Me.Width = 800
        If Me.Height < 450 Then Me.Height = 450
        PbLogo.Left = Me.Width - PbLogo.Width - 15
        'PbChan.Height = Me.Height - 150
        'PbWave.Height = Me.Height - 150
        PbWave.Width = Me.Width - 170
        Application.DoEvents()
        On Error Resume Next
        RedrawTraces()
        RedrawChan()
    End Sub


    Private Sub RedrawChan()
        Dim ScrnBuff As Bitmap = New Bitmap(PbChan.Width, PbChan.Height, Me.CreateGraphics())
        Dim g As Graphics = Graphics.FromImage(ScrnBuff)
        Dim pb As Graphics = PbChan.CreateGraphics

        Dim GridColor As Color = Color.FromArgb(50, 50, 50)
        Dim TraceColor As Color = Color.FromArgb(50, 255, 50)
        Dim PenGrid As New Pen(GridColor)
        Dim PenTrace As New Pen(TraceColor)
        Dim FontTxt As New Font("Arial", 16)
        Dim BrushTxt As New SolidBrush(Color.White)

        Dim PenChanBack As Brush

        Dim i As Integer
        PenGrid.Width = 1
        g.Clear(Color.Black)
        g.SmoothingMode = Drawing2D.SmoothingMode.None




        For i = 0 To 7
            If ColorChann = True Then
                g.FillRectangle(New SolidBrush(Chan(i).Color), 0, i * ChGridSize + DispOfset, PbChan.Width, ChGridSize)
            End If
            g.DrawLine(PenGrid, 0, i * ChGridSize + DispOfset, PbChan.Width, i * ChGridSize + DispOfset)
            g.DrawString(Chan(i).Name, FontTxt, BrushTxt, 0, i * ChGridSize + DispOfset + 2)
        Next
        g.DrawLine(PenGrid, 0, i * ChGridSize + DispOfset, PbChan.Width, i * ChGridSize + DispOfset)
        'g.DrawLine(PenGrid, PbChan.Width - 1, DispOfset, PbChan.Width - 1, i * ChGridSize + DispOfset)


        pb.DrawImage(ScrnBuff, New Point(0, 0))
    End Sub


    Private Sub RedrawTraces()
        On Error GoTo err
        Const TrH = 5
        Dim TrL = ChGridSize - TrH
        Dim i As Integer, a As Integer
        Dim DrawDis As Single = PbWave.Width / DispZoom
        Dim DrawStep As Single = PbWave.Width / DrawDis
        Dim ScrnBuff As Bitmap = New Bitmap(PbWave.Width, PbWave.Height, Me.CreateGraphics())
        Dim pb As Graphics = PbWave.CreateGraphics
        Dim g As Graphics = Graphics.FromImage(ScrnBuff)

        Dim GridColor As Color = Color.FromArgb(50, 50, 50)
        Dim TraceColor As Color = Color.FromArgb(50, 255, 50)
        Dim PenGrid As New Pen(GridColor)
        Dim PenTrace As New Pen(TraceColor)
        Dim PenFadeOut As New Pen(GridColor)
        Dim PenMarker As New Pen(GridColor)
        PenMarker.Width = 3

        Dim FontTxt As New Font("Arial", 12)
        Dim BrushTxt As New SolidBrush(Color.White)
        Dim FormatTxt As New StringFormat
        FormatTxt.Alignment = StringAlignment.Center

        g.Clear(Color.Black)
        g.SmoothingMode = Drawing2D.SmoothingMode.None

        Dim Lpos As Integer
        Dim Lstat As Integer
        Dim Cur As Integer
        Dim tmpH As Integer
        Dim tmpL As Integer
        Dim tmpS As Integer
        Dim Lp As Integer
        Dim points(10000) As Point

        For a = 0 To 7
            tmpL = TrL + (ChGridSize * a) + DispOfset
            tmpH = TrH + (ChGridSize * a) + DispOfset
            Lstat = (TmpDat(DispPos) >> a) And 1
            Lpos = 0
            ReDim points(100000)
            Lp = 0
            For i = 0 To DrawDis
                Cur = (TmpDat(i + DispPos) >> a) And 1
                If Cur <> Lstat Then
                    If Lstat = 0 Then
                        tmpS = tmpL

                    Else
                        tmpS = tmpH
                        points(Lp) = New Point(Lpos * DrawStep, tmpS + 1)
                        Lp += 1
                        points(Lp) = New Point(i * DrawStep, tmpS + 1)
                        Lp += 1
                    End If
                    points(Lp) = New Point(Lpos * DrawStep, tmpS)
                    Lp += 1
                    points(Lp) = New Point(i * DrawStep, tmpS)
                    Lp += 1
                    Lstat = Cur
                    Lpos = i
                End If
            Next
            If Lstat = 0 Then
                tmpS = tmpL
            Else
                tmpS = tmpH
                points(Lp) = New Point(Lpos * DrawStep, tmpS + 1)
                Lp += 1
                points(Lp) = New Point(i * DrawStep, tmpS + 1)
                Lp += 1
            End If
            points(Lp) = New Point(Lpos * DrawStep, tmpS)
            Lp += 1
            points(Lp) = New Point(i * DrawStep, tmpS)

            ReDim Preserve points(Lp)
            If ColorTraces = True Then PenTrace.Color = Chan(a).Color
            g.DrawLines(PenTrace, points)
        Next

        For i = 0 To 100
            If Marker(i).Position > DispPos And Marker(i).Position < DispPos + DrawDis Then
                PenMarker.Color = Marker(i).Color
                tmpS = (Marker(i).Position - DispPos) * DrawStep
                g.DrawLine(PenMarker, tmpS, 20, tmpS, PbWave.Height)
                g.DrawString(i, FontTxt, BrushTxt, tmpS, 0, FormatTxt)
            End If
        Next

        If ColorChann = True Then
            For a = 0 To 7
                For i = 0 To 85
                    PenFadeOut.Color = Color.FromArgb(255 - i * 3, Chan(a).Color.R, Chan(a).Color.G, Chan(a).Color.B)
                    g.DrawLine(PenFadeOut, i, DispOfset + (a * ChGridSize), i, DispOfset + ((a + 1) * ChGridSize))
                Next i
            Next a
            For i = 0 To 85
                PenFadeOut.Color = Color.FromArgb(255 - i * 3, 0, 0, 0)
                g.DrawLine(PenFadeOut, i, 0, i, DispOfset)
            Next i
        Else
            For i = 0 To 85
                g.DrawLine(PenFadeOut, i, 0, i, PbWave.Height)
            Next i
        End If

        'PenGrid.Color = Color.FromArgb(255, 50, 50, 50)
        For i = 0 To 8
            g.DrawLine(PenGrid, 0, i * ChGridSize + DispOfset, PbWave.Width, i * ChGridSize + DispOfset)
        Next


        pb.DrawImage(ScrnBuff, New Point(0, 0))
        'Pbuf.Update()
        ' Pbox.Image = Pbuf.Image
err:
    End Sub

    Private Sub StartTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartTimer.Tick
        'StartTimer.Enabled = False
        RedrawTraces()
        RedrawChan()
    End Sub

    Private Sub PbWave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PbWave.Click

    End Sub

    Private Sub Form1_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseWheel
        If MouseInPbWave = True Then
            If e.Delta.ToString = 120 Then
                WaveZoomIn()
            Else
                WaveZoomOut()
            End If
        End If
    End Sub

    Private Sub WaveZoomOut()
        Dim curpos
        If DispZoom > 0.1 Then
            If DispZoom < 2 Then
                DispZoom -= 0.1
            ElseIf DispZoom < 10 Then
                DispZoom -= 1
            Else
                DispZoom -= 5
            End If
            curpos = MouseXWave / DispZoom
            'DispPos = curpos * (DispZoom + 1 / DispZoom)
            'If DispPos < 0 Then DispPos = 0
        End If
        RedrawTraces()
    End Sub

    Private Sub WaveZoomIn()
        Dim curpos
        If DispZoom < 100 Then
            If DispZoom < 1 Then
                DispZoom += 0.1
            ElseIf DispZoom < 10 Then
                DispZoom += 1
            Else
                DispZoom += 5
            End If
            curpos = MouseXWave / DispZoom
            'DispPos = curpos * (DispZoom - 1 / DispZoom)
        End If
        RedrawTraces()
    End Sub

    Private Sub PbWave_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PbWave.MouseDown
        ClickX = e.X
        ClickY = e.Y
        DispPosTmp = DispPos
        MouseIsDown = True
    End Sub

    Private Sub PbWave_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles PbWave.MouseEnter
        MouseInPbWave = True
    End Sub

    Private Sub PbWave_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles PbWave.MouseLeave
        MouseInPbWave = False
    End Sub

    Private Sub PbWave_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PbWave.MouseMove
        MouseXWave = e.Location.X
        MouseYWave = e.Location.Y
        If MouseIsDown = True Then
            DispPos = DispPosTmp + (ClickX - e.Location.X) / DispZoom
            If DispPos < 0 Then DispPos = 0
            RedrawTraces()
        End If
    End Sub

    Private Sub PbWave_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PbWave.MouseUp
        MouseIsDown = False
    End Sub

    Private Sub PbWave_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PbWave.Paint
        RedrawTraces()
    End Sub

    Private Sub PbChan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PbChan.Click

    End Sub

    Private Sub PbChan_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PbChan.MouseUp
        Dim clicked As Integer = (e.Y - DispOfset) \ ChGridSize
        If clicked < 0 Or clicked > 8 Then Return
        If Panel1.Visible = True Then
            Chan(ChanSel).Name = TextBox1.Text
            Chan(ChanSel).Color = Label2.BackColor
            Application.DoEvents()
            Panel1.Hide()
            RedrawChan()
        End If
        ChanSel = clicked
        Label2.BackColor = Chan(clicked).Color
        TextBox1.Text = Chan(clicked).Name
        Panel1.Top = clicked * ChGridSize + DispOfset + PbChan.Top
        Panel1.Show()
    End Sub

    Private Sub PbChan_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PbChan.Paint
        RedrawChan()
    End Sub

    Private Sub PbCont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If ConNum > 10 Then
            ConSuc = False
            Timer1.Enabled = False
            Label1.Text = "Not found!"
            Exit Sub
        End If

        If Com.IsOpen = True Then
            If Com.BytesToRead > 0 Then
                If ChrW(Com.ReadChar) = "P" Then
                    Timer1.Enabled = False
                    ConSuc = True
                    Label1.Text = "Connected COM" & ConNum
                    Com.Write("I")
                    Threading.Thread.Sleep(200)
                    Me.Refresh()
                    ConIdent = Com.ReadChar
                    ConIdent = Com.ReadExisting()
                    Label1.Text = "Connected COM" & ConNum & vbCrLf & ConIdent
                    Exit Sub
                Else
                    Label1.Text = "Err resp at COM" & ConNum
                    ConNum += 1
                End If
            Else
                Label1.Text = "No resp at COM" & ConNum
                ConNum += 1
            End If
        End If
        Com.Close()
        Com.PortName = "COM" & ConNum
        On Error GoTo err
        Com.Open()
        While Com.IsOpen = False

        End While
        Com.Write("P")

        Exit Sub
err:
        Label1.Text = "Err at COM" & ConNum
        ConNum += 1
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ConNum = 1
        ConSuc = False
        ConIdent = "None"
        Timer1.Enabled = True
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        DispZoom = 0.1
        RedrawTraces()
    End Sub

    Private Sub Label2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Label2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label2.Click
        Dim Dialog As New ColorDialog()
        Dialog.Color = Label2.BackColor

        If (Dialog.ShowDialog() = DialogResult.OK) Then
            Label2.BackColor = Dialog.Color
        End If

    End Sub

    Private Sub Button4_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Chan(ChanSel).Name = TextBox1.Text
        Chan(ChanSel).Color = Label2.BackColor
        Panel1.Hide()
        Application.DoEvents()
        RedrawChan()
    End Sub
End Class
