﻿Imports System
Imports System.IO
Public Class MainWindow





    Dim ChGridSize As Integer = 30
    Dim DispOfset As Integer = 50
    Dim DispEnd As Integer = 10000
    Dim DispPos As Integer
    Dim DispZoom As Single
    Dim DispSampRate As Long = 1000000
    Dim DispMinimapPos As Integer = 300
    Dim DispMinimapSize As Integer = 30
    Dim TmpDat(65536) As Byte
    Dim Marker(100) As StrucMarker
    Dim Chan(8) As StrucChannel

    Dim MouseInPbWave As Boolean
    Dim MouseXWave As Integer
    Dim MouseYWave As Integer
    Dim ClickX As Integer
    Dim ClickY As Integer
    Dim MouseDownTrig As Boolean
    Dim MouseDownTrigTmp As Integer
    Dim MouseDownWave As Boolean
    Dim MouseDownMap As Boolean
    Dim MouseDownMark As Boolean
    Dim MouseDownMarkIndex As Integer
    Dim DispPosTmp As Integer

    Dim ChanSel As Integer

    Public ColorTraces As Boolean = True
    Public ColorChann As Boolean = False
    Public ColorChanDarken As Integer = 100

    Public GridColor As Color = Color.FromArgb(50, 50, 50)
    Public TraceColor As Color = Color.FromArgb(50, 255, 50)
    Public ChanColor As Color = Color.FromArgb(0, 0, 0)

    Public MapHColor As Color = Color.FromArgb(0, 100, 0)
    Public MapLColor As Color = Color.FromArgb(100, 0, 0)
    Public MapTColor As Color = Color.FromArgb(200, 200, 100)

    Dim ConfigFilename As String = Application.StartupPath & "\settings.ini"

    Dim ImgTrig(4) As Bitmap
    Dim ImgMarker As Bitmap
    Dim ImgDat(3) As Bitmap
    Dim ImgChanMask As Bitmap
    Dim ImgMarkerTmp As New Bitmap(40, 40)
    Dim m As Graphics

    Dim ConNum As Integer
    Dim ConState As Integer
    Dim ConProg As Integer
    Dim ConSuc As Boolean
    Dim ConTimeout As Integer
    Dim ConIdent As String

    Dim SampRate As Integer
    Dim SampSize As Integer

    Dim g As Graphics
    Dim pb As Graphics
    Dim ScrnBuffW As Bitmap
    Dim ScrnBuffC As Bitmap
    Dim Minimap As Bitmap

    Private Structure StrucChannel
        Dim Data() As Boolean
        Dim Color As Color
        Dim Name As String
        Dim Triger As Integer
    End Structure

    Private Structure StrucMarker
        Dim Position As Integer
        Dim Color As Color
        Dim Name As String
    End Structure

    


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        DispPos = 0
        DispZoom = 5
        Dim i As Integer
        'For i = 0 To 10000
        '    TmpDat(i) = i And 255
        'Next

        'For i = 20000 To 60000
        '    TmpDat(i) = (i * 17.245) And 255
        'Next
        For i = 0 To 100
            Marker(i).Position = -100000
        Next

        Marker(0).Position = 1000
        Marker(0).Color = Color.Aqua

        Marker(1).Position = 900
        Marker(1).Color = Color.Red

        For i = 0 To 7
            Chan(i).Name = "Chan" & (i + 1)
            Chan(i).Color = Color.FromArgb(255, 190, 0)
            Chan(i).Triger = 4
        Next

        Chan(1).Triger = 3
        Chan(4).Triger = 1

        ImgDat(0) = My.Resources.DataBubStart
        ImgDat(1) = My.Resources.DataBubMid
        ImgDat(2) = My.Resources.DataBubEnd
        ImgTrig(0) = My.Resources.TrigIsL
        ImgTrig(1) = My.Resources.TrigIsH
        ImgTrig(2) = My.Resources.TrigEdgeL
        ImgTrig(3) = My.Resources.TrigEdgeH
        ImgTrig(4) = My.Resources.TrigNone
        ImgMarker = My.Resources.marker
        ImgChanMask = My.Resources.chanmask

        My.Settings.Reload()

        ConfigLoad()

        Application.DoEvents()
        RedrawMinimap()
        RedrawTraces()
        RedrawChan()
    End Sub


    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Me.Width < 800 Then Me.Width = 800
        If Me.Height < 450 Then Me.Height = 450
        PbLogo.Left = Me.Width - PbLogo.Width - 15
        'PbChan.Height = Me.Height - 150
        'PbWave.Height = Me.Height - 150
        PbWave.Width = Me.Width - 170
        Application.DoEvents()
        On Error Resume Next
        RedrawMinimap()
        RedrawTraces()
        RedrawChan()

    End Sub


    Public Sub RedrawMinimap()
        Minimap = New Bitmap(PbWave.Width, DispMinimapSize)
        g = Graphics.FromImage(Minimap)
        Dim cur As Integer
        Dim curpix As Integer
        Dim DrawStep As Single = DispEnd / PbWave.Width
        Dim PenTrace As New Pen(Color.Green)
        Dim PenMarker As New Pen(Color.Aqua)
        Dim i As Single
        Dim tmps As Integer

        g.Clear(Color.Black)
        For a = 0 To 7
            curpix = (TmpDat(0) >> a) And 1
            For i = 0 To PbWave.Width

                For p = 0 To DrawStep
                    cur = (TmpDat(p + i * DrawStep) >> a) And 1
                    If cur <> curpix Then
                        curpix = 2
                        Exit For
                    End If
                Next p
                Select Case curpix
                    Case 0
                        PenTrace.Color = MapLColor
                    Case 1
                        PenTrace.Color = MapHColor
                    Case 2
                        PenTrace.Color = MapTColor
                        curpix = cur
                End Select
                g.DrawRectangle(PenTrace, i, a * 3, 1, 1)
            Next i
        Next a

        For i = 0 To 100
            If Marker(i).Position > 0 And Marker(i).Position < DispEnd Then
                PenMarker.Color = Marker(i).Color
                tmps = Marker(i).Position / DrawStep
                g.DrawLine(PenMarker, tmps, 0, tmps, 50)

            End If
        Next

    End Sub

    Public Sub RedrawChan()
        ScrnBuffC = New Bitmap(PbChan.Width, PbChan.Height, Me.CreateGraphics())
        g = Graphics.FromImage(ScrnBuffC)
        pb = PbChan.CreateGraphics

        Dim PenGrid As New Pen(GridColor)
        Dim PenTrace As New Pen(TraceColor)
        Dim FontTxt As New Font("Arial", 12)
        Dim BrushTxt As New SolidBrush(Color.White)

        Dim PenChanBack As Brush

        Dim i As Integer
        PenGrid.Width = 1
        g.Clear(Color.Black)
        g.SmoothingMode = Drawing2D.SmoothingMode.None




        For i = 0 To 7
            If ColorChann = True Then
                g.FillRectangle(New SolidBrush(Color.FromArgb(OverZero(Chan(i).Color.R - ColorChanDarken), OverZero(Chan(i).Color.G - ColorChanDarken), OverZero(Chan(i).Color.B - ColorChanDarken))), 0, i * ChGridSize + DispOfset, PbChan.Width, ChGridSize)
            Else
                g.FillRectangle(New SolidBrush(ChanColor), 0, i * ChGridSize + DispOfset, PbChan.Width, ChGridSize)
            End If
            g.DrawImage(ImgChanMask, 0, i * ChGridSize + DispOfset, 150, 30)
            g.DrawLine(PenGrid, 0, i * ChGridSize + DispOfset, PbChan.Width, i * ChGridSize + DispOfset)
            g.DrawString(Chan(i).Name, FontTxt, BrushTxt, 0, i * ChGridSize + DispOfset + 5)
            If Chan(i).Triger < 0 Then Chan(i).Triger = 4
            If Chan(i).Triger > 4 Then Chan(i).Triger = 4
            If Chan(i).Triger < 4 Then
                g.DrawImage(ImgTrig(Chan(i).Triger), 120, i * ChGridSize + DispOfset, 30, 30)
            End If
            If Chan(i).Triger = 4 Then
                g.DrawImage(ImgTrig(4), 127, 7 + i * ChGridSize + DispOfset, 5, 5)
            End If
        Next
        g.DrawLine(PenGrid, 0, i * ChGridSize + DispOfset, PbChan.Width, i * ChGridSize + DispOfset)
        'g.DrawLine(PenGrid, PbChan.Width - 1, DispOfset, PbChan.Width - 1, i * ChGridSize + DispOfset)


        Dim MarkDif As Integer = Math.Abs(Marker(0).Position - Marker(1).Position)
        Dim TimeDif As Double = MarkDif / DispSampRate
        Dim FreqDif As Double = DispSampRate / MarkDif
        Dim TmpStr As String
        If TimeDif < 0.000001 Then
            TmpStr = Format(TimeDif * 1000000000, "0.### ns")
        ElseIf TimeDif < 0.001 Then
            TmpStr = Format(TimeDif * 1000000, "0.### us")
        ElseIf TimeDif < 1 Then
            TmpStr = Format(TimeDif * 1000, "0.### ms")
        Else
            TmpStr = Format(TimeDif, "0.### s")
        End If
        g.DrawString(TmpStr, FontTxt, BrushTxt, 0, 0)
        If MarkDif <> 0 Then
            If FreqDif >= 1000000 Then
                TmpStr = Format(FreqDif / 1000000, "0.### MHz")
            ElseIf FreqDif >= 1000 Then
                TmpStr = Format(FreqDif / 1000, "0.### KHz")
            Else
                TmpStr = Format(FreqDif, "0.### Hz")
            End If
        Else
            TmpStr = "--- Hz"
        End If
        g.DrawString(TmpStr, FontTxt, BrushTxt, 0, 15)

        pb.DrawImage(ScrnBuffC, New Point(0, 0))
    End Sub


    Public Sub RedrawTraces()
        On Error GoTo err
        Const TrH = 5
        Dim TrL = ChGridSize - TrH
        Dim i As Integer, a As Integer
        Dim DrawDis As Single = PbWave.Width / DispZoom
        Dim DrawStep As Single = PbWave.Width / DrawDis
        Dim MapStep As Single = DispEnd / PbWave.Width
        ScrnBuffW = New Bitmap(PbWave.Width, PbWave.Height, Me.CreateGraphics())
        pb = PbWave.CreateGraphics
        g = Graphics.FromImage(ScrnBuffW)
        m = Graphics.FromImage(ImgMarkerTmp)

        Dim PenGrid As New Pen(GridColor)
        Dim PenTrace As New Pen(TraceColor)
        Dim PenFadeOut As New Pen(ChanColor)
        Dim PenMarker As New Pen(GridColor)
        PenMarker.Width = 3

        Dim FontTxt As New Font("Arial", 12)
        Dim BrushTxt As New SolidBrush(Color.White)
        Dim FormatTxt As New StringFormat
        FormatTxt.Alignment = StringAlignment.Center

        g.Clear(Color.Black)
        g.SmoothingMode = Drawing2D.SmoothingMode.None

        Dim Lpos As Integer
        Dim Lstat As Integer
        Dim Cur As Integer
        Dim tmpH As Integer
        Dim tmpL As Integer
        Dim tmpS As Integer
        Dim Lp As Integer
        Dim points(10000) As Point

        For a = 0 To 7
            tmpL = TrL + (ChGridSize * a) + DispOfset
            tmpH = TrH + (ChGridSize * a) + DispOfset
            Lstat = (TmpDat(DispPos) >> a) And 1
            Lpos = 0
            ReDim points(100000)
            Lp = 0
            For i = 0 To DrawDis
                Cur = (TmpDat(i + DispPos) >> a) And 1
                If Cur <> Lstat Then
                    If Lstat = 0 Then
                        tmpS = tmpL

                    Else
                        tmpS = tmpH
                        points(Lp) = New Point(Lpos * DrawStep, tmpS + 1)
                        Lp += 1
                        points(Lp) = New Point(i * DrawStep, tmpS + 1)
                        Lp += 1
                    End If
                    points(Lp) = New Point(Lpos * DrawStep, tmpS)
                    Lp += 1
                    points(Lp) = New Point(i * DrawStep, tmpS)
                    Lp += 1
                    Lstat = Cur
                    Lpos = i
                End If
            Next
            If Lstat = 0 Then
                tmpS = tmpL
            Else
                tmpS = tmpH
                points(Lp) = New Point(Lpos * DrawStep, tmpS + 1)
                Lp += 1
                points(Lp) = New Point(i * DrawStep, tmpS + 1)
                Lp += 1
            End If
            points(Lp) = New Point(Lpos * DrawStep, tmpS)
            Lp += 1
            points(Lp) = New Point(i * DrawStep, tmpS)

            ReDim Preserve points(Lp)
            If ColorTraces = True Then PenTrace.Color = Chan(a).Color
            g.DrawLines(PenTrace, points)
        Next

        For i = 0 To 100
            If Marker(i).Position > DispPos And Marker(i).Position < DispPos + DrawDis Then
                PenMarker.Color = Marker(i).Color
                tmpS = (Marker(i).Position - DispPos) * DrawStep
                m = Graphics.FromImage(ImgMarkerTmp)
                m.Clear(Marker(i).Color)
                m.DrawImage(ImgMarker, 0, 0, 40, 40)
                m.DrawString(i, FontTxt, BrushTxt, 20, 8, FormatTxt)
                ImgMarkerTmp.MakeTransparent(Color.Black)
                g.DrawImage(ImgMarkerTmp, tmpS - 20, 0)
                g.DrawLine(PenMarker, tmpS, 38, tmpS, 290)

            End If
        Next

        If ColorChann = True Then
            For a = 0 To 7
                For i = 0 To 51
                    PenFadeOut.Color = Color.FromArgb(255 - i * 5, OverZero(Chan(a).Color.R - ColorChanDarken), OverZero(Chan(a).Color.G - ColorChanDarken), OverZero(Chan(a).Color.B - ColorChanDarken))

                    g.DrawLine(PenFadeOut, i, DispOfset + (a * ChGridSize), i, DispOfset + ((a + 1) * ChGridSize))
                Next i
            Next a
            For i = 0 To 51
                PenFadeOut.Color = Color.FromArgb(255 - i * 5, 0, 0, 0)
                g.DrawLine(PenFadeOut, i, 0, i, DispOfset)
            Next i
        Else
            For i = 0 To 51
                PenFadeOut.Color = Color.FromArgb(255 - i * 5, ChanColor.R, ChanColor.G, ChanColor.B)
                g.DrawLine(PenFadeOut, i, DispOfset, i, DispOfset + ChGridSize * 8)
            Next i
            For i = 0 To 25
                PenFadeOut.Color = Color.FromArgb(255 - i * 10, 0, 0, 0)
                g.DrawLine(PenFadeOut, i, 0, i, DispOfset)
            Next i
        End If

        'PenGrid.Color = Color.FromArgb(255, 50, 50, 50)
        For i = 0 To 8
            g.DrawLine(PenGrid, 0, i * ChGridSize + DispOfset, PbWave.Width, i * ChGridSize + DispOfset)
        Next


        ''MakeDataBuble(120, 110, 100, "", Color.FromArgb(255, 100, 0), 200)

        g.DrawImage(Minimap, 0, DispMinimapPos, Minimap.Width, Minimap.Height)
        g.DrawRectangle(Pens.White, DispPos / MapStep, 295, DrawDis / MapStep, 32)

        pb.DrawImage(ScrnBuffW, New Point(0, 0))

        'Pbuf.Update()
        ' Pbox.Image = Pbuf.Image
err:
    End Sub

    Private Sub MakeDataBuble(ByVal Xpos As Integer, ByVal Ypos As Integer, ByVal lenth As Integer, ByVal Text As String, ByVal color As Color, ByVal alpha As Byte)
        Dim imageAttributes As New Imaging.ImageAttributes()

        Dim height As Integer = 30
        Dim width As Integer = 20

        g = Graphics.FromImage(ScrnBuffW)

        Dim colorMatrixElements As Single()() = { _
           New Single() {color.R / 255, color.G / 255, color.B / 255, 0, 0}, _
           New Single() {0, 0, 0, 0, 0}, _
           New Single() {1, 1, 1, 1, 0}, _
           New Single() {0, 0, 0, alpha / 255, 0}, _
           New Single() {0, 0, 0, 0, 1}}

        Dim colorMatrix As New Imaging.ColorMatrix(colorMatrixElements)

        imageAttributes.SetColorMatrix( _
           colorMatrix, _
            Imaging.ColorMatrixFlag.Default, _
            Imaging.ColorAdjustType.Bitmap)

        g.DrawImage( _
           ImgDat(0), _
           New Rectangle(Xpos, Ypos, width, height), _
           0, 0, _
           ImgDat(0).Width, _
           ImgDat(0).Height, _
           GraphicsUnit.Pixel, _
           imageAttributes)

        g.DrawImage( _
         ImgDat(2), _
         New Rectangle(Xpos + width, Ypos, lenth, height), _
         0, 0, _
         1, _
         ImgDat(1).Height, _
         GraphicsUnit.Pixel, _
         imageAttributes)

        g.DrawImage( _
           ImgDat(2), _
           New Rectangle(Xpos + lenth + width, Ypos, width, height), _
           0, 0, _
           ImgDat(0).Width, _
           ImgDat(0).Height, _
           GraphicsUnit.Pixel, _
           imageAttributes)
    End Sub

    Public Function OverZero(ByVal value As Integer) As Integer
        If value > 0 Then
            Return value
        Else
            Return 0
        End If
    End Function

    Private Sub StartTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartTimer.Tick
        'StartTimer.Enabled = False
        RedrawTraces()
        RedrawChan()
    End Sub

    Private Sub PbWave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PbWave.Click

    End Sub

    Private Sub Form1_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseWheel
        If MouseInPbWave = True Then
            If e.Delta.ToString >= 120 Then
                WaveZoomIn()
            Else
                WaveZoomOut()
            End If
        End If
    End Sub

    Private Sub WaveZoomOut()
        Dim curpos
        Dim ozoom = DispZoom
        Dim DrawDis As Single = PbWave.Width / DispZoom
        If DispZoom > 0.1 Then
            If DispZoom < 2 Then
                DispZoom -= 0.1
            ElseIf DispZoom < 10 Then
                DispZoom -= 1
            Else
                DispZoom -= 5
            End If
            DrawDis = PbWave.Width / DispZoom
            curpos = MouseXWave / DispZoom
            DispPos = DispPos + (curpos * (DispZoom / ozoom)) - curpos
            If DispZoom < PbWave.Width / DispEnd Then DispZoom = PbWave.Width / DispEnd
            If DispPos > DispEnd - DrawDis Then DispPos = DispEnd - DrawDis
            If DispPos < 0 Then DispPos = 0
        End If
        RedrawTraces()
    End Sub

    Private Sub WaveZoomIn()
        Dim curpos
        Dim ozoom = DispZoom
        Dim DrawDis As Single = PbWave.Width / DispZoom
        If DispZoom < 100 Then
            If DispZoom < 1 Then
                DispZoom += 0.1
            ElseIf DispZoom < 10 Then
                DispZoom += 1
            Else
                DispZoom += 5
            End If
            curpos = MouseXWave / DispZoom
            DispPos = DispPos + (curpos * (DispZoom / ozoom)) - curpos
            If DispPos > DispEnd - DrawDis Then DispPos = DispEnd - DrawDis
            If DispPos < 0 Then DispPos = 0
        End If
        RedrawTraces()
    End Sub

    Private Sub PbWave_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PbWave.MouseDown
        ClickX = e.X
        ClickY = e.Y
        If ClickY > DispOfset And ClickY < 300 Then
            DispPosTmp = DispPos
            MouseDownWave = True
        ElseIf ClickY > DispMinimapPos And ClickY < DispMinimapPos + DispMinimapSize Then
            MouseDownMap = True
        ElseIf ClickY < DispOfset Then
            Dim DrawDis As Single = PbWave.Width / DispZoom
            Dim DrawStep As Single = PbWave.Width / DrawDis
            Dim mpos As Integer = DispPos + ClickX / DrawStep
            Dim abspos As Integer
            For i = 0 To 100
                abspos = Math.Abs(Marker(i).Position - mpos)
                If abspos < 10 / DrawStep Then
                    MouseDownMarkIndex = i
                    MouseDownMark = True
                End If
            Next
        End If
    End Sub

    Private Sub PbWave_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles PbWave.MouseEnter
        MouseInPbWave = True
    End Sub

    Private Sub PbWave_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles PbWave.MouseLeave
        MouseInPbWave = False
    End Sub

    Private Sub PbWave_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PbWave.MouseMove
        MouseXWave = e.Location.X
        MouseYWave = e.Location.Y
        If MouseDownWave = True Then
            Dim DrawDis As Single = PbWave.Width / DispZoom
            DispPos = DispPosTmp + (ClickX - e.Location.X) / DispZoom
            If DispPos < 0 Then DispPos = 0
            If DispPos > DispEnd - DrawDis Then DispPos = DispEnd - DrawDis
            RedrawTraces()
            PbWave.Cursor = Cursors.Hand
        End If
        If MouseDownMap = True Then
            Dim MapStep As Single = DispEnd / PbWave.Width
            Dim DrawDis As Single = PbWave.Width / DispZoom
            Dim mpos As Integer = OverZero(MouseXWave - (DrawDis / MapStep) / 2)
            DispPos = mpos * MapStep
            If DispPos > DispEnd - DrawDis Then DispPos = DispEnd - DrawDis
            RedrawTraces()
            PbWave.Cursor = Cursors.Hand
        End If
        If MouseDownMark = True Then
            Dim DrawDis As Single = PbWave.Width / DispZoom
            Dim DrawStep As Single = PbWave.Width / DrawDis
            Dim mpos As Integer = DispPos + MouseXWave / DrawStep
            Marker(MouseDownMarkIndex).Position = mpos
            If Marker(MouseDownMarkIndex).Position < 1 Then Marker(MouseDownMarkIndex).Position = 1
            If Marker(MouseDownMarkIndex).Position > DispEnd Then Marker(MouseDownMarkIndex).Position = DispEnd
            RedrawTraces()
            RedrawChan()
            PbWave.Cursor = Cursors.NoMoveHoriz
        End If
    End Sub

    Private Sub PbWave_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PbWave.MouseUp
        MouseDownWave = False
        MouseDownMap = False
        MouseDownMark = False
        PbWave.Cursor = Cursors.Arrow
        Application.DoEvents()
        RedrawMinimap()
    End Sub

    Private Sub PbWave_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PbWave.Paint
        e.Graphics.DrawImage(ScrnBuffW, 0, 0)
    End Sub

    Private Sub PbChan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PbChan.Click

    End Sub

    Private Sub PbChan_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PbChan.MouseDown
        If e.X > 120 Then
            Dim sel As Integer = (e.Y - DispOfset) \ ChGridSize
            Dim selt As Integer = e.X \ 30
            Dim tmph As Integer = sel * ChGridSize + DispOfset
            Dim g As Graphics = Graphics.FromImage(ScrnBuffC)
            pb = PbChan.CreateGraphics
            If ColorChann = True Then
                g.FillRectangle(New SolidBrush(Color.FromArgb(OverZero(Chan(sel).Color.R - ColorChanDarken), OverZero(Chan(sel).Color.G - ColorChanDarken), OverZero(Chan(sel).Color.B - ColorChanDarken))), 0, tmph, 150, ChGridSize)
            Else
                g.FillRectangle(New SolidBrush(ChanColor), 0, tmph, 150, ChGridSize)
            End If
            g.DrawImage(ImgChanMask, 0, tmph, 150, ChGridSize)

            For i = 0 To 4
                If i = selt Then
                    g.DrawImage(ImgTrig(i), i * 30, tmph, 30, 30)
                Else
                    g.DrawImage(ImgTrig(i), 5 + i * 30, tmph, 20, 20)
                End If
            Next i
            pb.DrawImage(ScrnBuffC, New Point(0, 0))
            MouseDownTrig = True
            MouseDownTrigTmp = sel
        End If
    End Sub

    Private Sub PbChan_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PbChan.MouseMove
        If MouseDownTrig = True Then
            Dim sel As Integer = MouseDownTrigTmp
            Dim selt As Integer = e.X \ 30
            Dim tmph As Integer = sel * ChGridSize + DispOfset
            Dim g As Graphics = Graphics.FromImage(ScrnBuffC)
            pb = PbChan.CreateGraphics
            If ColorChann = True Then
                g.FillRectangle(New SolidBrush(Color.FromArgb(OverZero(Chan(sel).Color.R - ColorChanDarken), OverZero(Chan(sel).Color.G - ColorChanDarken), OverZero(Chan(sel).Color.B - ColorChanDarken))), 0, tmph, 150, ChGridSize)
            Else
                g.FillRectangle(New SolidBrush(ChanColor), 0, tmph, 150, ChGridSize)
            End If

            g.DrawImage(ImgChanMask, 0, tmph, 150, ChGridSize)

            For i = 0 To 4
                If i = selt Then
                    g.DrawImage(ImgTrig(i), i * 30, tmph, 30, 30)
                Else
                    g.DrawImage(ImgTrig(i), 5 + i * 30, tmph, 20, 20)
                End If
            Next i
            pb.DrawImage(ScrnBuffC, New Point(0, 0))
        End If
    End Sub



    Private Sub PbChan_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PbChan.MouseUp
        On Error Resume Next
        Dim clicked As Integer = (e.Y - DispOfset) \ ChGridSize
        If clicked < 0 Or clicked > 8 Then Return
        If Panel1.Visible = True Then
            Chan(ChanSel).Name = TextBox1.Text
            Chan(ChanSel).Color = Label2.BackColor
            Application.DoEvents()
            Panel1.Hide()
            RedrawChan()
        End If
        If MouseDownTrig = True Then
            Chan(MouseDownTrigTmp).Triger = e.X \ 30
            MouseDownTrig = False
            RedrawChan()
        Else
            ChanSel = clicked
            Label2.BackColor = Chan(clicked).Color
            TextBox1.Text = Chan(clicked).Name
            Panel1.Top = clicked * ChGridSize + DispOfset + PbChan.Top
            Panel1.Show()
        End If
    End Sub

    Private Sub PbChan_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PbChan.Paint
        e.Graphics.DrawImage(ScrnBuffC, 0, 0)
    End Sub

    Private Sub PbCont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
start:
        ' On Error GoTo err
        Application.DoEvents()
        If ConNum > 10 Then
            ConSuc = False
            Timer1.Enabled = False
            Label1.Text = "Not found!"
            Exit Sub
        End If

        If Com.IsOpen = True Then
            If Com.BytesToRead > 0 Then
                If ChrW(Com.ReadChar) = "P" Then
                    Timer1.Enabled = False
                    ConSuc = True
                    Label1.Text = "Connected COM" & ConNum
                    Com.Write("I")
                    Threading.Thread.Sleep(200)
                    Me.Refresh()
                    ConIdent = Com.ReadChar
                    ConIdent = Com.ReadExisting()
                    Label1.Text = "Connected COM" & ConNum & vbCrLf & ConIdent
                    Exit Sub
                Else
                    Label1.Text = "Err resp at COM" & ConNum
                    ConNum += 1
                End If
            Else
                Label1.Text = "No resp at COM" & ConNum
                ConNum += 1
            End If
        End If
        Com.Close()
        Com.PortName = "COM" & ConNum

        'Label3.Text = Label3.Text & Com.PortName & vbCrLf
        Try
            Com.Open()
        Catch ex As Exception
            GoTo err
        End Try
        While Com.IsOpen = False

        End While
        Com.Write("P")

        Exit Sub
err:
        Label1.Text = "Err at COM" & ConNum
        ConNum += 1
        Application.DoEvents()
        GoTo start
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ConNum = 1
        ConSuc = False
        ConIdent = "None"
        Timer1.Enabled = True
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        DispZoom = 0.1
        RedrawTraces()
    End Sub

    Private Sub Label2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub Label2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label2.Click
        Dim Dialog As New ColorDialog()
        Dialog.Color = Label2.BackColor

        If (Dialog.ShowDialog() = DialogResult.OK) Then
            Label2.BackColor = Dialog.Color

            Chan(ChanSel).Name = TextBox1.Text
            Chan(ChanSel).Color = Label2.BackColor
            Panel1.Hide()
            Application.DoEvents()
            RedrawChan()
            RedrawTraces()
        End If

    End Sub

    Private Sub Button4_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Chan(ChanSel).Name = TextBox1.Text
        Chan(ChanSel).Color = Label2.BackColor
        Panel1.Hide()
        Application.DoEvents()
        RedrawChan()
        RedrawTraces()
    End Sub

    Private Sub TextBox1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBox1.KeyDown
        If e.KeyCode = Keys.Enter Then
            Chan(ChanSel).Name = TextBox1.Text
            Chan(ChanSel).Color = Label2.BackColor
            Panel1.Hide()
            Application.DoEvents()
            RedrawChan()
            RedrawTraces()
        End If
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Options.Show()
        Options.Left = Me.Left + Me.Width \ 2 - Options.Width \ 2
        Options.Top = Me.Top + Me.Height \ 2 - Options.Height \ 2
        Me.Enabled = False
        Application.DoEvents()
        RedrawChan()
        RedrawTraces()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim TrLen As UInteger
        Dim tmp As Char
        On Error GoTo err
        Button2.Enabled = False
        Button2.Text = "Initialising"
        Com.Write("C")
        Com.Write(SampRate)
        Com.Write(SampSize)
        Me.Refresh()
        Threading.Thread.Sleep(100)
        If Com.BytesToRead > 0 Then
retry:
            tmp = ChrW(Com.ReadChar)
            If tmp <> "C" Then
                If Com.BytesToRead > 0 Then GoTo retry
                GoTo err
            End If
        Else
            MsgBox("Communication error!")
            GoTo err
        End If
        Button2.Text = "Capturing..."
        Button6.Visible = True
        Me.Refresh()
        While Com.BytesToRead < 3
            '' Me.Refresh()
            Threading.Thread.Sleep(1)
            Application.DoEvents()
        End While
        TrLen = 0
        If ChrW(Com.ReadChar) = "D" Then
            TrLen = Com.ReadByte
            TrLen = TrLen + (Com.ReadByte << 8)
        End If
        While Com.BytesToRead < TrLen + 1
            Threading.Thread.Sleep(10)
        End While
        Com.Read(TmpDat, 0, TrLen)
        If ChrW(Com.ReadChar) <> "D" Then
            MsgBox("Communication error!")
            GoTo err
        End If
        DispEnd = TrLen

        RedrawMinimap()
        RedrawTraces()
err:
        Button6.Visible = False
        Button2.Enabled = True
        Button2.Text = "Capture"
    End Sub

    Private Sub ComboBox2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox2.SelectedIndexChanged

    End Sub

    Private Sub ComboBox2_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox2.SelectionChangeCommitted
        PbWave.Select()
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged

    End Sub

    Private Sub ComboBox1_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectionChangeCommitted
        PbWave.Select()
    End Sub


    Public Sub ConfigSave()
        Dim svfl As StreamWriter
        svfl = File.CreateText(ConfigFilename)
        'svfl = File.CreateText("C:\test.txt")
        Using sw As StreamWriter = svfl
            sw.WriteLine("Xlogic config 001")
            sw.WriteLine(SampRate)
            sw.WriteLine(SampSize)
            sw.WriteLine(ColorTraces)
            sw.WriteLine(ColorChann)
            sw.WriteLine(TraceColor.R)
            sw.WriteLine(TraceColor.G)
            sw.WriteLine(TraceColor.B)
            sw.WriteLine(GridColor.R)
            sw.WriteLine(GridColor.G)
            sw.WriteLine(GridColor.B)
            sw.WriteLine(ChanColor.R)
            sw.WriteLine(ChanColor.G)
            sw.WriteLine(ChanColor.B)
            For i = 0 To 7
                sw.WriteLine(Chan(i).Name)
                sw.WriteLine(Chan(i).Triger)
                sw.WriteLine(Chan(i).Color.R)
                sw.WriteLine(Chan(i).Color.G)
                sw.WriteLine(Chan(i).Color.B)
            Next
            sw.Close()
        End Using


    End Sub


    Public Sub ConfigLoad()
        On Error GoTo err
        Dim TmpR As Byte
        Dim TmpG As Byte
        Dim TmpB As Byte
        Dim svfl As StreamReader
        svfl = File.OpenText(ConfigFilename)
        'svfl = File.CreateText("C:\test.txt")

        Using sw As StreamReader = svfl
            If svfl.ReadLine() <> "Xlogic config 001" Then GoTo err
            SampRate = svfl.ReadLine()
            SampSize = svfl.ReadLine()
            If svfl.ReadLine() = Boolean.TrueString Then ColorTraces = True Else ColorTraces = False
            If svfl.ReadLine() = Boolean.TrueString Then ColorChann = True Else ColorChann = False
            TmpR = svfl.ReadLine()
            TmpG = svfl.ReadLine()
            TmpB = svfl.ReadLine()
            TraceColor = Color.FromArgb(TmpR, TmpG, TmpB)
            TmpR = svfl.ReadLine()
            TmpG = svfl.ReadLine()
            TmpB = svfl.ReadLine()
            GridColor = Color.FromArgb(TmpR, TmpG, TmpB)
            TmpR = svfl.ReadLine()
            TmpG = svfl.ReadLine()
            TmpB = svfl.ReadLine()
            ChanColor = Color.FromArgb(TmpR, TmpG, TmpB)
            For i = 0 To 7
                Chan(i).Name = svfl.ReadLine()
                Chan(i).Triger = svfl.ReadLine()
                TmpR = svfl.ReadLine()
                TmpG = svfl.ReadLine()
                TmpB = svfl.ReadLine()
                Chan(i).Color = Color.FromArgb(TmpR, TmpG, TmpB)
            Next
            sw.Close()
        End Using

        Exit Sub
err:
        File.Delete(ConfigFilename)
        ConfigSave()
    End Sub


    Private Sub MainWindow_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

    End Sub

    Private Sub MainWindow_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        ConfigSave()
    End Sub



    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Dim fd As New SaveFileDialog
        Dim svfl As StreamWriter

        fd.Filter = "Waveform save files (*.xwf)|*.xwf"
        fd.FilterIndex = 1
        fd.RestoreDirectory = True
        fd.Title = "Save Waveform"

        If fd.ShowDialog() = DialogResult.OK Then
            svfl = File.CreateText(fd.FileName)
            Using sw As StreamWriter = svfl
                sw.WriteLine("Wafeform Save 001")
                sw.WriteLine(SampSize)
                sw.WriteLine(SampRate)
                sw.WriteLine(DispEnd)
                For i = 0 To DispEnd
                    sw.WriteLine(TmpDat(i))
                Next
                sw.Close()
            End Using
        End If
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        Dim fd As New OpenFileDialog
        Dim svfl As StreamReader

        fd.Filter = "Waveform save files (*.xwf)|*.xwf|All files|*.*"
        fd.FilterIndex = 1
        fd.RestoreDirectory = True
        fd.Title = "Open Waveform"

        If fd.ShowDialog() = DialogResult.OK Then
            svfl = File.OpenText(fd.FileName)
            Using sw As StreamReader = svfl
                If svfl.ReadLine() <> "Wafeform Save 001" Then GoTo err
                SampSize = svfl.ReadLine()
                SampRate = svfl.ReadLine()
                DispEnd = svfl.ReadLine()
                For i = 0 To DispEnd
                    TmpDat(i) = svfl.ReadLine()
                Next
                sw.Close()
            End Using
        End If
        RedrawMinimap()
        RedrawTraces()
        RedrawChan()
        Exit Sub
err:
        Using sw As StreamReader = svfl
            sw.Close()
        End Using
        RedrawMinimap()
        RedrawTraces()
        RedrawChan()
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        MsgBox("Not Implemented")
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        MsgBox("Not Implemented")
    End Sub
End Class
